function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import getBasePlacement from '../utils/getBasePlacement';
export function distanceAndSkiddingToXY(placement, measures, getOffsets) {
  const basePlacement = getBasePlacement(placement);
  const invertDistance = ['left', 'top'].includes(basePlacement) ? -1 : 1;
  const invertSkidding = ['top', 'bottom'].includes(basePlacement) ? -1 : 1;
  let [distance, skidding] = getOffsets(_objectSpread({}, measures, {
    placement
  }));
  distance = (distance || 0) * invertDistance;
  skidding = (distance || 0) * invertSkidding;
  return ['left', 'right'].includes(basePlacement) ? [distance, skidding] : [skidding, distance];
}
export function offset(state, options) {
  if (options && typeof options.offset === 'function') {
    const [x, y] = distanceAndSkiddingToXY(state.placement, state.measures, options.offset);
    state.offsets.popper.x += x;
    state.offsets.popper.y += y;
  }

  return state;
}
export default {
  name: 'offset',
  enabled: true,
  phase: 'main',
  fn: offset
};